%global momorel 2
%global md5sum_src0 75903ca41fe8b7729d1a02987625e90f
%global pyver 2.5

Summary: The Beagle Search Infrastructure
Name: beagle

Version: 0.2.17
Release: %{momorel}m%{?dist}
License: LGPL
Group: User Interface/Desktops
URL: http://beagle-project.org/

%NoSource 0  ftp://ftp.gnome.org/pub/GNOME/sources/%{name}/0.2/%{name}-%{version}.tar.bz2 %{md5sum_src0}
Source1: beagle.desktop

Patch2: beagle-0.2.7-crawl.patch
Patch3: beagle-0.2.1-spew.patch
Patch4: beagle-0.2.6-lib64.patch
Patch5: beagle-0.2.17.epiphany.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires:  pkgconfig
BuildRequires:  mono-core >= 1.2.3.1
BuildRequires:  mono-devel mono-data-sqlite
BuildRequires:  gtk-sharp2-devel >= 2.10.0
BuildRequires:  gnome-sharp-devel >= 2.16.0
BuildRequires:  zip libexif-devel
BuildRequires:  gsf-sharp >= 0.8.1
BuildRequires:  sqlite-devel >= 3.3.17
BuildRequires:  gmime-sharp >= 2.2.1-3m
BuildRequires:  evolution-sharp >= 0.12.4
BuildRequires:  libXScrnSaver-devel
BuildRequires:  gnome-vfs2-devel >= 2.18.1
BuildRequires:  libgnome-devel >= 2.18.0
BuildRequires:  gtk2-devel >= 2.10.12
BuildRequires:  librsvg2-devel >= 2.16.1
BuildRequires:  wv >= 1.2.4
BuildRequires:  shared-mime-info >= 0.21
BuildRequires:  glib2-devel >= 2.12.12
BuildRequires:  galago-sharp-devel >= 0.5.0
BuildRequires:  pygtk-devel >= 2.10.4
BuildRequires:  pygobject-devel >= 2.12.3
BuildRequires:  atk-devel >= 1.18.0
BuildRequires:  libexif-devel >= 0.6.13
BuildRequires:  libxml2-devel >= 2.6.28
BuildRequires:  epiphany-devel >= 2.18.1
BuildRequires:  libglade2-devel >= 2.6.0
Requires: sqlite >= 3.3.5
Requires: zip unzip sed grep
PreReq: shadow-utils

# Mono only available on these:
ExclusiveArch: %ix86 x86_64 ppc ia64 armv4l sparc s390 s390x

%description
A general infrastructure for making your data easy to find.

%package -n libbeagle
Summary:      Beagle C interface
Group:        Development/Libraries

%description -n libbeagle
Library to talk to the beagle server in C.

%package -n libbeagle-devel
Summary:      Beagle C interface
Group:        Development/Libraries
Requires:     libbeagle = %{version} libxml2-devel glib-devel

%description -n libbeagle-devel
Library to talk to the beagle server in C.

%package -n libbeagle-python
Summary:      Beagle python interface
Group:        Development/Libraries
Requires:     libbeagle = %{version}
Requires:     python >= %{pyver}
BuildRequires:python-devel >= %{pyver}

%description -n libbeagle-python
Python wrappers for libbeagle


%package doc
Summary:      Beagle document
Group:        Documentation
Requires:     beagle = %{version}

%description doc
Beagle document

%prep
%setup -q
%patch2 -p1 -b .crawl
%patch3 -p1 -b .spew
%patch5 -p1 -b .epiphany

%build
export MONO_SHARED_DIR=%{buildroot}/%{?buildsubdir}
mkdir -p ${MONO_SHARED_DIR}
autoreconf -fi
%configure --enable-sqlite3 \
    --enable-gtk-doc \
    --enable-evolution \
    --enable-thunderbird \
    --enable-epiphany-extension \
    --enable-epiphany-extension-install \
    --enable-xml-dump \
    --program-transform-name=""
%make

# Generate the beagle.xpi for mozilla/firefox
pushd .
cd mozilla-extension
%make
popd

%install
rm -rf --preserve-root %{buildroot}
export MONO_SHARED_DIR=%{buildroot}/%{?buildsubdir}
mkdir -p ${MONO_SHARED_DIR}

%make install DESTDIR=%{buildroot}

mkdir -p %{buildroot}/var/cache/beagle/indexes

# TODO: Isn't there a better place to install this?
install -m 644 mozilla-extension/beagle.xpi %{buildroot}%{_libdir}/beagle/

desktop-file-install --vendor gnome --delete-original           \
  --dir %{buildroot}%{_datadir}/applications                 \
  --add-only-show-in=GNOME                                      \
  --remove-category=Application \
  --remove-category=X-Ximian-Settings \
  %{buildroot}%{_datadir}/applications/beagle-search.desktop

desktop-file-install --vendor gnome --delete-original           \
  --dir %{buildroot}%{_datadir}/applications                 \
  --remove-category Utility                                     \
  --remove-category=X-Ximian-Settings \
  --remove-category=AdvancedSettings \
  --remove-category=Application \
  --add-only-show-in=GNOME                                      \
  %{buildroot}%{_datadir}/applications/beagle-settings.desktop

# echo "NoDisplay=true" >> %{buildroot}%{_datadir}/applications/gnome-beagle-search.desktop

#sed -i -e 's@Icon=tango-system-search@Icon=gnome-search-tool@' %{buildroot}%{_datadir}/applications/gnome-beagle-search.desktop

%find_lang %{name}

rm -f %{buildroot}%{_libdir}/beagle/*.la
rm -f %{buildroot}%{_libdir}/beagle/*.a
rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_libdir}/*.a
rm -f %{buildroot}%{_libdir}/python*/site-packages/*.a
rm -f %{buildroot}%{_libdir}/python*/site-packages/*.la

chmod a+x %{buildroot}%{_libdir}/beagle/*/*.dll
chmod a+x %{buildroot}%{_libdir}/beagle/*.dll
chmod a+x %{buildroot}%{_libdir}/beagle/*.exe

# I do not want to autostart
echo "X-GNOME-autostart-enabled = False" >> %{buildroot}/%{_sysconfdir}/xdg/autostart/beagle-search-autostart.desktop
echo "X-GNOME-autostart-enabled = False" >> %{buildroot}/%{_sysconfdir}/xdg/autostart/beagled-autostart.desktop

%post -n libbeagle -p /sbin/ldconfig

%postun -n libbeagle -p /sbin/ldconfig

%pre
%define beagle_user_uid 58

/usr/sbin/groupadd -g %{beagle_user_uid} -r beagleindex 2> /dev/null || :
/usr/sbin/useradd -r -u %{beagle_user_uid} -s /sbin/nologin -c "User for Beagle indexing" -d /var/cache/beagle -g beagleindex beagleindex 2> /dev/null || :

%post
if rpm -q firefox > /dev/null; then
# install the firefox extension
# note that this code is duplicated below in a trigger
  latest=`rpm --query --queryformat "%{VERSION}\n" firefox | head -1 | tr -d "\n\r"`
  if [ -d %{_libdir}/firefox-$latest/extensions ]; then
    cd %{_libdir}/firefox-$latest/extensions
    mkdir beagle-extension
    unzip -q -d beagle-extension %{_libdir}/beagle/beagle.xpi
    id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
    if [ -e "$id" ]; then
      rm -rf beagle-extension
    else
      mv beagle-extension "$id"
    fi
  fi
fi

%clean
rm -rf --preserve-root %{buildroot}

%triggerin -- firefox
# install the firefox extension
latest=`rpm --query --queryformat "%{VERSION}\n" firefox | head -1 | tr -d "\n\r"`
if [ -d /usr/lib64/firefox-$latest/extensions ]; then
  libdir=/usr/lib64
else
  libdir=/usr/lib
fi
if [ -f $libdir/beagle/beagle.xpi ]; then
  cd $libdir/firefox-$latest/extensions
  mkdir beagle-extension
  unzip -q -d beagle-extension $libdir/beagle/beagle.xpi
  id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
  if [ -e "$id" ]; then
    rm -rf beagle-extension
  else
    mv beagle-extension "$id"
  fi
fi

%files
%defattr(-,root,root,-)
%doc COPYING README
%{_sysconfdir}/cron.daily/*
%dir %{_sysconfdir}/beagle
%config(noreplace) %{_sysconfdir}/beagle/crawl-applications
%config(noreplace) %{_sysconfdir}/beagle/crawl-documentation
%config(noreplace) %{_sysconfdir}/beagle/external-filters.xml.sample
%{_bindir}/*
%{_sbindir}/*
%{_libdir}/pkgconfig/beagle*.pc
%{_libdir}/beagle
%{_libdir}/epiphany/2.18/extensions/*
%{_datadir}/beagle
%{_datadir}/pixmaps/*
%{_datadir}/applications/*
%{_datadir}/locale/*/*/*
%{_mandir}/*/*
%dir %attr(-,beagleindex,beagleindex) /var/cache/beagle
%dir %attr(-,beagleindex,beagleindex) /var/cache/beagle/indexes
%{_sysconfdir}/xdg/autostart/beagle-search-autostart.desktop
%{_sysconfdir}/xdg/autostart/beagled-autostart.desktop

%files -n libbeagle
%defattr(-, root, root)
%{_libdir}/libbeagle.so.*

%files -n libbeagle-devel
%defattr(-, root, root)
%{_includedir}/libbeagle
%{_libdir}/libbeagle.so
%{_libdir}/pkgconfig/libbeagle*.pc

%files -n libbeagle-python
%defattr(-, root, root)
%{_libdir}/python*/site-packages/beagle.so

%files doc
%defattr(-, root, root)
%{_datadir}/gtk-doc/html/%{name}

%changelog
* Mon May 21 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.17-2m)
- enable evolution-sharp gsf-sharp epiphany

* Wed May  9 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.2.17-1m)
- update to 0.2.17

* Sun Mar 18 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.16.3-1m)
- update to 0.2.16.3

* Sat Feb 24 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.16.2-1m)
- up to 0.2.16.2
- delete patch6 (build fix)

* Mon Feb 12 2007 Mitsuru Shimamura <smbd@momonga-liunx.org>
- (0.2.16-1m)
- up to 0.2.16

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.2.14-2m)
- rebuild against python-2.5

* Tue Dec 19 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.14-1m)
- update to 0.2.14
- add "X-GNOME-autostart-enabled = False" to %%{_sysconfdir}/xdg/autostart/*

* Fri Nov  3 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.12-2m)
- add doc package

* Fri Nov  3 2006 NARITA Koichi <pulsar@momonga-linux.org>
- (0.2.12-1m)
- update to 0.2.12
- rebuild against wv-1.2.4-1m

* Sat Oct 21 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.11-1m)
- update to 0.2.11

* Tue Sep 19 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.10-1m)
- update to 0.2.10

* Fri Sep 15 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.9-2m)
- remove category Application X-Ximian-Settings AdvancedSettings

* Mon Sep  4 2006 NARITA Koichi <pulsar@sea.plala.or.jp>
- (0.2.9-1m)
- update to 0.2.9
- do not apply patch5

* Tue Aug 29 2006 NARITA Koichi <pulsar@sea.plala.or.jp>
- (0.2.7-6m)
- rebuild against expat-2.0.0-1m

* Tue Aug 29 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.7-5m)
- rebuils against gtk-sharp
- add requires gnome-sharp
- add Patch5 (conflict Gtk.TrayIcon and Search.Tray.TrayIcon)

* Thu Aug 17 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.7-4m)
- rebuild against wv-1.2.1-3m

* Sun Aug 13 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.2.7-3m)
- revised for multilibarch

* Wed Jul 12 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.2.7-2m)
- stop beagle-crawl (cron.daily)

* Sun Jul  9 2006 NARITA Koichi <pulsar@sea.plala.or.jp>
- (0.2.7-1m)
- update to 0.2.7

* Sat Jun 24 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (0.2.6-6m)
- depend sqlite3 -> sqlite

* Tue Jun  6 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.6-5m)
- Fix BuildPrereq (mono package name changed)

* Thu May 25 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.6-4m)
- delete duplicate dir

* Sun May 21 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.2.6-3m)
- BuildRequires:  wv >= 1.2.1

* Wed May 17 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.2.6-2m)
- add Patch4: beagle-0.2.6-lib64.patch

* Tue May 16 2006 Masaru SANUKI <sanuki@momonga-linux.org>
- (0.2.6-1m)
- version 0.2.6
- First import, based on Fedora
